﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace DynamicCVPBackgroundDepOnProperty
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            (Root.Resources["MainVM"] as MainVM).ChangeBaseLine();
        }
    }

    public class BaseLineToBGColorConverter : IMultiValueConverter
    {

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values[0] != null && values[1] != null && values[0] is DataObjectVM && values[1] is DataObjectVM)
            {
                DataObjectVM baseline = values[0] as DataObjectVM;
                DataObjectVM current = values[1] as DataObjectVM;
                if (baseline.ID == current.ID && baseline.Name.Equals(current.Name) && baseline.Value == current.Value)
                {
                    return "true";
                }
                else
                {
                    return "false";
                }
            }
            return "false";
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


    public class MainVM : VMBase
    {
        private ObservableCollection<DataObjectVM> data;
        private DataObjectVM baseLine;
        Random r = new Random();


        public MainVM()
        {
            data = new ObservableCollection<DataObjectVM>();

            for (int i = 0; i < 20; i++)
            {
                data.Add(new DataObjectVM { ID = i % 5, Name = "name " + i % 5, Value = (i % 5) * 12 });
            }

      
            BaseLine = data[2];
        }

        public ObservableCollection<DataObjectVM> Data
        {
            get
            {
                return data;
            }
        }

        public void ChangeBaseLine()
        {
            int newBaseLineIndex = r.Next(data.Count);

            BaseLine = data[newBaseLineIndex];
        }

        public DataObjectVM BaseLine
        {
            get { return baseLine; }
            set
            {
                baseLine = value;
                OnPropertyChanged("BaseLine");
            }
        }


    }
    
    public class DataObjectVM : VMBase
    {
        private int id;
        private int value;
        private string name;

        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                OnPropertyChanged("ID");
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                OnPropertyChanged("Name");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                OnPropertyChanged("Value");
            }
        }

    }

    public class VMBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string prop)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }
    }

}
